{$IFDEF PATCH_HEART}
unit sdlinit;

interface

uses
	sysutils,
{$IFDEF SDL2}
	SDL2,SDL2_Image
  {$IFDEF PATCH_HEART}
	,SDL2_TTF
  {$ELSE PATCH_HEART}
  {$ENDIF PATCH_HEART}
{$ELSE SDL2}
	SDL,SDL_Image
{$ENDIF SDL2}
	;

var
{$IF DEFINED(PATCH_HEART) and DEFINED(SDL2)}
	QRLViewer_WindowID: Integer;
{$ENDIF}
	SDL_VideoModeFlag: LongWord;
{$IFDEF SDL2}
	Game_Window: PSDL_Window;
	Game_WindowID: Integer;
	Game_Renderer: PSDL_Renderer;
	Mouse_Pointer: PSDL_Texture;
{$ELSE SDL2}
	Game_Screen: PSDL_Surface;
	Mouse_Pointer: PSDL_Surface;
{$ENDIF SDL2}



implementation

uses
{$IF DEFINED(SDL2) and (DEFINED(FreeBSD) or DEFINED(LINUX))}
	math,
{$ENDIF}
{$IFDEF PATCH_GH}
	errmsg,pseudosmartpointer,
{$ELSE PATCH_GH}
  {$IFDEF DEBUG}
	errmsg,
  {$ENDIF DEBUG}
{$ENDIF PATCH_GH}
{$IFDEF PATCH_I18N}
	i18nmsg,
{$ENDIF PATCH_I18N}
	gears_base,
	gears,
	texutil,
	ui4gh;

const
	WindowName: PChar = 'GearHead Arena SDL Version';
	IconName: PChar = 'GearHead';


{$IFDEF SDL2}
Function CreateTextureFromIMG_withColorKey( FileName: PChar ): PSDL_Texture;
var
	tmp_Surface: PSDL_Surface;
begin
	tmp_Surface := IMG_Load( FileName );
	SDL_SetColorKey( tmp_Surface , 1 , SDL_MapRGB( tmp_Surface^.Format , 0 , 0, 255 ) );
	CreateTextureFromIMG_withColorKey := SDL_CreateTextureFromSurface( Game_Renderer , tmp_Surface );
	SDL_FreeSurface( tmp_Surface );
end;
{$ELSE SDL2}
{$ENDIF SDL2}

Procedure InitVideo;
{$IF DEFINED(SDL2) and (DEFINED(FreeBSD) or DEFINED(LINUX))}
var
	FPUExceptionMask: TFPUExceptionMask;
{$ENDIF}
begin
{$IFDEF PATCH_GH}
	if (ScreenSize_Width <= 0) then begin
		ScreenSize_Width := 800;
	end;
	if (ScreenSize_Height <= 0) then begin
		ScreenSize_Height := 600;
	end;
{$ENDIF PATCH_GH}

{$IF DEFINED(SDL2) and (DEFINED(FreeBSD) or DEFINED(LINUX))}
	FPUExceptionMask := GetExceptionMask;
	if SDL_Accelerated then begin
		FPUExceptionMask := FPUExceptionMask + [exInvalidOp, exZeroDivide];
	end;
  {$IF DEFINED(SDL2) and DEFINED(LINUX)}
	SetExceptionMask( FPUExceptionMask + [exInvalidOp, exZeroDivide] );
  {$ENDIF}
{$ENDIF}
{$IF DEFINED(PATCH_AUDIO)}
	SDL_Init( SDL_INIT_VIDEO or SDL_INIT_TIMER or SDL_INIT_AUDIO );
{$ELSEIF DEFINED(PATCH)}
	SDL_Init( SDL_INIT_VIDEO or SDL_INIT_TIMER );
{$ELSE}
	SDL_Init( SDL_INIT_VIDEO or SDL_INIT_AUDIO );
{$ENDIF}
{$IF DEFINED(SDL2) and (DEFINED(FreeBSD) or DEFINED(LINUX))}
	SetExceptionMask( FPUExceptionMask );
{$ENDIF}

{$IFDEF PATCH_GH}
	SDL_SetHint( SDL_HINT_RENDER_SCALE_QUALITY , 'best' );
	SDL_VideoModeFlag := 0;
{$ENDIF PATCH_GH}

{$IFDEF SDL2}
	if DoFullScreen then begin
  {$IFDEF PATCH_GH}
		SDL_VideoModeFlag := SDL_WINDOW_FULLSCREEN;
		Game_Window := SDL_CreateWindow(WindowName, SDL_WINDOWPOS_UNDEFINED,SDL_WINDOWPOS_UNDEFINED, ScreenSize_Width, ScreenSize_Height, SDL_VideoModeFlag );
  {$ELSE PATCH_GH}
		Game_Window := SDL_CreateWindow(WindowName, SDL_WINDOWPOS_UNDEFINED,SDL_WINDOWPOS_UNDEFINED, ScreenWidth, ScreenHeight, SDL_HWSURFACE or SDL_FULLSCREEN or SDL_DoubleBuf );
  {$ENDIF PATCH_GH}
	end else begin
  {$IFDEF PATCH_GH}
		SDL_VideoModeFlag := SDL_WINDOW_RESIZABLE;
		if ( ( -1 <> ScreenPos_X ) and ( -1 <> ScreenPos_Y ) ) then begin
			Game_Window := SDL_CreateWindow(WindowName, ScreenPos_X, ScreenPos_Y, ScreenSize_Width, ScreenSize_Height, SDL_VideoModeFlag );
		end else begin
			Game_Window := SDL_CreateWindow(WindowName, SDL_WINDOWPOS_UNDEFINED,SDL_WINDOWPOS_UNDEFINED, ScreenSize_Width, ScreenSize_Height, SDL_VideoModeFlag );
		end;
  {$ELSE PATCH_GH}
		Game_Window := SDL_CreateWindow(WindowName, SDL_WINDOWPOS_UNDEFINED,SDL_WINDOWPOS_UNDEFINED, ScreenWidth, ScreenHeight, SDL_HWSURFACE or SDL_DoubleBuf or SDL_RESIZABLE );
  {$ENDIF PATCH_GH}
	end;
	Mouse_Pointer := NIL;
  {$IFDEF PATCH_GH}
	if (NIL = Game_Window) then begin
		ErrorMessage('SDL_CreateWindow() failed. : ' + SDL_GetError);
		halt(255);
	end;
  {$ENDIF PATCH_GH}
  {$IF DEFINED(SDL2) and (DEFINED(LINUX))}
	FPUExceptionMask := GetExceptionMask;
	SetExceptionMask( FPUExceptionMask + [exInvalidOp, exZeroDivide] );
  {$ENDIF}
	Game_Renderer := SDL_CreateRenderer( Game_Window , -1 , SDL_RendererMode );
  {$IF DEFINED(SDL2) and (DEFINED(LINUX))}
	SetExceptionMask( FPUExceptionMask );
  {$ENDIF}
  {$IFDEF PATCH_GH}
	if (NIL = Game_Renderer) then begin
		ErrorMessage('SDL_CreateRenderer() failed. : ' + SDL_GetError);
		halt(255);
	end;
  {$ENDIF PATCH_GH}
	Game_WindowID := SDL_GetWindowID( Game_Window );
  {$IFDEF PATCH_HEART}
	QRLViewer_WindowID := -1;
  {$ENDIF PATCH_HEART}
	if DoFullScreen then begin
		Mouse_Pointer := CreateTextureFromIMG_withColorKey( Graphics_Directory + 'cosplay_pointer.png' );
	end;
{$ELSE SDL2}
	if DoFullScreen then begin
  {$IFDEF PATCH_GH}
		SDL_VideoModeFlag := ( SDL_HWSURFACE or SDL_FULLSCREEN or SDL_DoubleBuf );
		Game_Screen := SDL_SetVideoMode(ScreenSize_Width, ScreenSize_Height, 0, SDL_VideoModeFlag );
  {$ELSE PATCH_GH}
		Game_Screen := SDL_SetVideoMode(ScreenWidth, ScreenHeight, 0, SDL_HWSURFACE or SDL_FULLSCREEN or SDL_DoubleBuf );
  {$ENDIF PATCH_GH}
		Mouse_Pointer := IMG_Load( Graphics_Directory + 'cosplay_pointer.png' );
		SDL_SetColorKey( Mouse_Pointer , SDL_SRCCOLORKEY or SDL_RLEACCEL , SDL_MapRGB( Mouse_Pointer^.Format , 0 , 0, 255 ) );
	end else begin
  {$IFDEF PATCH_GH}
		SDL_VideoModeFlag := ( SDL_HWSURFACE or SDL_DoubleBuf or SDL_RESIZABLE );
		Game_Screen := SDL_SetVideoMode(ScreenSize_Width, ScreenSize_Height, 0, SDL_VideoModeFlag );
  {$ELSE PATCH_GH}
		Game_Screen := SDL_SetVideoMode(ScreenWidth, ScreenHeight, 0, SDL_HWSURFACE or SDL_DoubleBuf or SDL_RESIZABLE );
  {$ENDIF PATCH_GH}
		Mouse_Pointer := Nil;
	end;
  {$IFDEF PATCH_GH}
	if (NIL = Game_Screen) then begin
		ErrorMessage('SDL_SetVideoMode() failed. : ' + SDL_GetError);
		halt(255);
	end;
  {$ENDIF PATCH_GH}
  {$IFDEF PATCH_GH}
	if ( ( -1 <> ScreenPos_X ) and ( -1 <> ScreenPos_Y ) ) then begin
			SDL_VERSION( wmi.version );
			if ( 1 = SDL_GetWMInfo( @wmi ) ) then begin
    {$IF DEFINED(UNIX)}
				Pointer(gX11_Lock) := wmi.x11.lock_func;
				Pointer(gX11_Unlock) := wmi.x11.unlock_func;
				gX11_Lock;
				xlib.XMoveWindow( wmi.x11.display , wmi.x11.wmwindow , ScreenPos_X , ScreenPos_Y );
				gX11_Unlock;
    {$ENDIF}
    {$IF DEFINED(WINDOWS)}
				Windows.GetWindowRect( wmi.window , @r );
				Windows.MoveWindow( wmi.window , ScreenPos_X , ScreenPos_Y , ( r.right - r.left ) , ( r.bottom - r.top ) , FALSE );
    {$ENDIF}
			end;
		end;
  {$ENDIF PATCH_GH}
{$ENDIF SDL2}

{$IFDEF SDL2}
{$ELSE SDL2}
	SDL_EnableUNICODE( 1 );
	SDL_EnableKeyRepeat( GH_REPEAT_DELAY , GH_REPEAT_INTERVAL );
{$ENDIF SDL2}

{$IFDEF PATCH_HEART}
	TTF_Init;
{$ELSE PATCH_HEART}
{$ENDIF PATCH_HEART}
end;



initialization
begin
{$IFDEF DEBUG}
	ErrorMessage_fork('DEBUG: sdlinit.pp');
{$ENDIF DEBUG}
	InitVideo;
end;

finalization
begin
{$IFDEF DEBUG}
	ErrorMessage_fork('DEBUG: sdlinit.pp(finalization)');
{$ENDIF DEBUG}
{$IFDEF SDL2}
	if ( NIL <> Mouse_Pointer ) then begin
		SDL_DestroyTexture( Mouse_Pointer );
	end;

{$IFDEF PATCH_HEART}
	TTF_Quit;
{$ELSE PATCH_HEART}
{$ENDIF PATCH_HEART}

	SDL_DestroyRenderer( Game_Renderer );
{$ELSE SDL2}
	if Mouse_Pointer <> Nil then SDL_FreeSurface( Mouse_Pointer );

	SDL_FreeSurface( Game_Screen );
{$ENDIF SDL2}
	SDL_Quit;
end;

end.
{$ENDIF PATCH_HEART}
